Index: Makefile
===================================================================
--- Makefile	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ Makefile	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -163,17 +163,17 @@
 
 $(subdirs):
-	@$(MAKE) -C $@ $(MAKECMDGOALS)
+	$(MAKE) -C $@ $(MAKECMDGOALS)
 
 $(OTR_PI): %.so: $(_SRCDIR_)%.c
 	@echo '*' Building plugin $@
-	@$(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) $< -o $@ $(OTRFLAGS)
+	$(VERBOSE) $(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) $< -o $@ $(OTRFLAGS)
 
 $(SKYPE_PI): $(_SRCDIR_)protocols/skype/skype.c
 	@echo '*' Building plugin skype
-	@$(CC) $(CFLAGS) $(LDFLAGS) $(SKYPEFLAGS) $< -o $@
+	$(VERBOSE) $(CC) $(CFLAGS) $(LDFLAGS) $(SKYPEFLAGS) $< -o $@
 
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 $(objects): Makefile Makefile.settings config.h
@@ -181,8 +181,8 @@
 $(OUTFILE): $(objects) $(subdirs)
 	@echo '*' Linking $(OUTFILE)
-	@$(CC) $(objects) $(subdirobjs) -o $(OUTFILE) $(LDFLAGS_BITLBEE) $(LDFLAGS) $(EFLAGS)
+	$(VERBOSE) $(CC) $(objects) $(subdirobjs) -o $(OUTFILE) $(LDFLAGS_BITLBEE) $(LDFLAGS) $(EFLAGS)
 ifneq ($(firstword $(STRIP)), \#)
 	@echo '*' Stripping $(OUTFILE)
-	@-$(STRIP) $(OUTFILE)
+	$(VERBOSE) -$(STRIP) $(OUTFILE)
 endif
 
Index: configure
===================================================================
--- configure	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ configure	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -39,4 +39,5 @@
 purple=0
 
+verbose=0
 doc=1
 debug=0
@@ -125,4 +126,6 @@
 --pidfile=...						$pidfile
 --config=...						$config
+
+--verbose=0/1	Disable/enable verbose build		$verbose
 
 --msn=0/1	Disable/enable MSN part			$msn
@@ -281,4 +284,10 @@
 	LDFLAGS="$LDFLAGS -fsanitize=address"
 	debug=1
+fi
+
+if [ "$verbose" = "0" ]; then
+	echo 'VERBOSE=@' >> Makefile.settings
+else
+	echo 'VERBOSE=' >> Makefile.settings
 fi
 
Index: lib/Makefile
===================================================================
--- lib/Makefile	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ lib/Makefile	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -36,5 +36,5 @@
 lib.o: $(objects) $(subdirs)
 	@echo '*' Linking lib.o
-	@$(LD) $(LFLAGS) $(objects) -o lib.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o lib.o
 
 $(objects): ../Makefile.settings Makefile
@@ -42,5 +42,5 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 -include .depend/*.d
Index: protocols/Makefile
===================================================================
--- protocols/Makefile	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ protocols/Makefile	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -43,5 +43,5 @@
 
 $(subdirs):
-	@$(MAKE) -C $@ $(MAKECMDGOALS)
+	$(MAKE) -C $@ $(MAKECMDGOALS)
 
 ### MAIN PROGRAM
@@ -49,5 +49,5 @@
 protocols.o: $(objects) $(subdirs)
 	@echo '*' Linking protocols.o
-	@$(LD) $(LFLAGS) $(objects) $(subdirobjs) -o protocols.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) $(subdirobjs) -o protocols.o
 
 $(objects): ../Makefile.settings Makefile
@@ -55,5 +55,5 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 -include .depend/*.d
Index: protocols/jabber/Makefile
===================================================================
--- protocols/jabber/Makefile	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ protocols/jabber/Makefile	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -38,9 +38,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 jabber_mod.o: $(objects)
 	@echo '*' Linking jabber_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o jabber_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o jabber_mod.o
 
 -include .depend/*.d
Index: protocols/msn/Makefile
===================================================================
--- protocols/msn/Makefile	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ protocols/msn/Makefile	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -38,9 +38,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 msn_mod.o: $(objects)
 	@echo '*' Linking msn_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o msn_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o msn_mod.o
 
 -include .depend/*.d
Index: protocols/oscar/Makefile
===================================================================
--- protocols/oscar/Makefile	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ protocols/oscar/Makefile	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -39,9 +39,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 oscar_mod.o: $(objects)
 	@echo '*' Linking oscar_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o oscar_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o oscar_mod.o
 
 -include .depend/*.d
Index: protocols/purple/Makefile
===================================================================
--- protocols/purple/Makefile	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ protocols/purple/Makefile	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -39,9 +39,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 purple_mod.o: $(objects)
 	@echo '*' Linking purple_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o purple_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o purple_mod.o
 
 -include .depend/*.d
Index: protocols/twitter/Makefile
===================================================================
--- protocols/twitter/Makefile	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ protocols/twitter/Makefile	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -38,9 +38,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 twitter_mod.o: $(objects)
 	@echo '*' Linking twitter_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o twitter_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o twitter_mod.o
 	
 -include .depend/*.d
Index: tests/Makefile
===================================================================
--- tests/Makefile	(revision 262a82b875f2a05cdcf2258260c5e8a9e538f405)
+++ tests/Makefile	(revision 65d0dfdefa1e7813a1cb14ce3ae6fae163d4caf5)
@@ -21,7 +21,7 @@
 check: $(test_objs) $(addprefix ../, $(main_objs)) ../protocols/protocols.o ../lib/lib.o
 	@echo '*' Linking $@
-	@$(CC) $(CFLAGS) -o $@ $^ $(LFLAGS) $(EFLAGS)
+	$(VERBOSE) $(CC) $(CFLAGS) -o $@ $^ $(LFLAGS) $(EFLAGS)
 
 %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $< -o $@